#!/usr/bin/php -q
<?php
{
    // Version 1.11 2005-Nov-15
    // ------------
    // CONFIG Parms
    // ------------

    // If the application is having problems you can log to this file
    $parm_error_log = '/tmp/alarm.log';
    
    // Set to 1 to turn on the log file
    $parm_debug_on = 1;	
    

    GLOBAL	$stdin, $stdout, $stdlog, $result, $parm_debug_on, $parm_test_mode;
    
    // These setting are on the WIKI pages http://www.voip-info.org
    ob_implicit_flush(false);
    set_time_limit(30);
    error_reporting(0);
    
    $stdin = fopen( 'php://stdin', 'r' );
    $stdout = fopen( 'php://stdout', 'w' );
    
    // You will see a whole bunch of this its for development or if you change anything and
    // want to write to a log file in the TMP directory
    if ($parm_debug_on)
    {
        $stdlog = fopen( $parm_error_log, 'a' );
        fputs( $stdlog, "---Start---\n" );
    }
    
    
    // ASTERISK * Sends in a bunch of variables, This accepts them and puts them in an array
    // http://www.voip-info.org/tiki-index.php?page=Asterisk%20AGI%20php
    while ( !feof($stdin) ) 
    {
        $temp = fgets( $stdin );
        
        if ($parm_debug_on)
            fputs( $stdlog, $temp );
        
        // Strip off any new-line characters
        $temp = str_replace( "\n", "", $temp );
        
        $s = explode( ":", $temp );
        $agivar[$s[0]] = trim( $s[1] );
        if ( ( $temp == "") || ($temp == "\n") )
        {
            break;
        }
    } 
    
    
    $rc = execute_agi( "ANSWER ");
    
    sleep(1);	// Wait for the channel to get created and RTP packets to be sent
				// On my system the welcome you would only hear 'elcome'  So I paused for 1 second


    for ($lcv = 0; $lcv < 5; $lcv ++)
    {
    if ( !$rc[result] )
        $rc = execute_agi( "GET VARIABLE ID");
        $DBDID=$rc['variable'];
        $rc = execute_agi( "GET VARIABLE Description");
        $description=$rc['variable'];
        $rc = execute_agi( "GET VARIABLE Cause");
        $cause=$rc['variable'];
        $rc = execute_agi( "GET VARIABLE EventCode");
        $eventcode=$rc['variable'];
        $rc = execute_agi( "GET VARIABLE Zone");
        $zone=$rc['variable'];
        $rc = execute_agi( "GET VARIABLE Site");
        $site=$rc['variable'];

//    if ($parm_debug_on)
        fputs( $stdlog, "We have ID - $DBDID \r\n" );
        fputs( $stdlog, "We have Description - $description \r\n" );
        fputs( $stdlog, "We have Cause - $cause \r\n" );

        $rc[result]=0;       
    if ( !$rc[result] )
        $dbc = mysql_connect("server.domain.com.au", "root","passw0rd")
                 or fputs( $stdlog, "no database connection\r\n" );
        mysql_select_db("alarm",$dbc)
                 or fputs( $stdlog, "no database change\r\n" );
    $tmpfname = tempnam("/var/lib/asterisk/sounds", "ALARM-WAV");

    $rc = execute_agi( "STREAM FILE alarm-activated \"\" ");

    $rc = execute_agi( "STREAM FILE site \"\" ");
    exec("echo ${site} | /usr/bin/flite -o ${tmpfname}.wav");
    $bn = basename($tmpfname);
    $rc = execute_agi( "STREAM FILE $bn \"\" ");

    $rc = execute_agi( "STREAM FILE zone \"\" ");
    $rc = execute_agi( "SAY DIGITS $zone \"\" ");

    $rc = execute_agi( "STREAM FILE eventcode \"\" ");
    $rc = execute_agi( "SAY DIGITS $eventcode \"\" ");

    exec("echo ${description} | /usr/bin/flite -o ${tmpfname}.wav");
    $bn = basename($tmpfname);
    $rc = execute_agi( "STREAM FILE $bn \"\" ");

    exec("echo ${cause} | /usr/bin/flite -o ${tmpfname}.wav");
    $bn = basename($tmpfname);
    $rc = execute_agi( "STREAM FILE $bn \"\" ");
    unlink($tmpfname);
    unlink($tmpfname.".wav");


    $rc = execute_agi( "GET DATA alarm-response 10000 1");
    if ( $rc[result] != -1 )
    {
         if ($parm_debug_on)
             fputs( $stdlog, "We have num digits:" . strlen( $rc[result]) . "- $rc[result] \r\n\r\n" );
         if ($rc[result] == '1')
         {
                  if ($parm_debug_on)
                  {
                  	$sqlquery = "update output_events set ack = now() where id = ".$DBDID;
                        $result = mysql_query($sqlquery, $dbc);
                        fputs( $stdlog, "$sqlquery\r\n" );
                        fputs( $stdlog, "Acking event $DBDID\r\n" );
                        $rc = execute_agi( "STREAM FILE goodbye \"\" ");            
                        $rc = execute_agi( "HANGUP");
                  }
         }
         else
         {
                  if ($parm_debug_on)
                               fputs( $stdlog, "I should NOT ack here \r\n\r\n" );
         }
    }
}
    if ( !$rc[result] )
        $rc = execute_agi( "STREAM FILE goodbye \"\" ");
    if ( !$rc[result] )
        $rc = execute_agi( "HANGUP");
    if ($parm_debug_on)
        fclose($stdlog);
    exit;
}


// ----------------------------------------------
// This will say military time in AM/PM format
// ----------------------------------------------
function say_wakeup( $wtime )
{
    GLOBAL	$stdin, $stdout, $stdlog, $parm_debug_on;
    
    $pm = 0;
    
    if ($wtime > 1159 )
    {
        $wtime -=1200;
        $pm = 1;
    }
    
    if ($wtime <= 59 )
        $wtime += 1200;
    
    if ( strlen( $wtime ) == 3 )
        $wtime = '0' . $wtime;
    
    
    $h = substr( $wtime, 0, 2 );
    $h1 = substr( $wtime, 0, 1 );
    $h2 = substr( $wtime, 1, 1 );
    $m = substr( $wtime, 2, 2 );
    $m1 = substr( $wtime, 2, 1);
    $m2 = substr( $wtime, 3, 1);
    
    
    if ($parm_debug_on)
        fputs( $stdlog, "Wakeup time is set to $wtime\n" );
    
    $rc = execute_agi( "STREAM FILE rqsted-wakeup-for \"\" ");
    
    if ( !$rc[result] )
    {
        if ( $h1 == 0 ) 
            $rc = execute_agi( "SAY NUMBER $h2 \"\"");
        else
            $rc = execute_agi( "SAY NUMBER $h \"\"");
        
        if ( !$rc[result] )
        {
            if ($m == 0 )
                $rc = execute_agi( "STREAM FILE digits/oclock \"\" ");
            else
            {		
                if ( $m1 == 0 ) 
                {
                    $rc = execute_agi( "STREAM FILE digits/oh \"\" ");
                    $rc = execute_agi( "SAY NUMBER $m2 \"\" ");
                }
                else
                    $rc = execute_agi( "SAY NUMBER $m \"\"");
            }
            if ( !$rc[result] )
            {
                if ( $pm )
                    $rc = execute_agi( "STREAM FILE digits/p-m \"\" ");
                else
                    $rc = execute_agi( "STREAM FILE digits/a-m \"\" ");
            }
        }
    }	
}


//--------------------------------------------------
// This function will send out the command and get 
//	the response back
//--------------------------------------------------
function execute_agi( $command )
{
    GLOBAL	$stdin, $stdout, $stdlog, $parm_debug_on;
    
    fputs( $stdout, $command . "\n" );
    fflush( $stdout );
    if ($parm_debug_on)
        fputs( $stdlog, $command . "\n" );
    
    $resp = fgets( $stdin, 4096 );
    
    if ($parm_debug_on)
        fputs( $stdlog, $resp );
    
    if ( preg_match("/^([0-9]{1,3}) (.*)/", $resp, $matches) ) 
    {
        if (preg_match('/result=([-0-9a-zA-Z]*)(.*)/', $matches[2], $match)) 
        {
            $arr['code'] = $matches[1];
            $arr['result'] = $match[1];
            $arr['variable'] = $match[2];
            $arr['variable'] = str_replace(' (','',$arr['variable']);
            $arr['variable'] = str_replace(')','',$arr['variable']);
            if (isset($match[3]) && $match[3])
                $arr['data'] = $match[3];
            return $arr;
        } 
        else 
        {
            if ($parm_debug_on)
                fputs( $stdlog, "Couldn't figure out returned string, Returning code=$matches[1] result=0\n" );	
            $arr['code'] = $matches[1];
            $arr['result'] = 0;
            return $arr;
        }
   	} 
    else 
    {
        if ($parm_debug_on)
            fputs( $stdlog, "Could not process string, Returning -1\n" );
        $arr['code'] = -1;
        $arr['result'] = -1;
        return $arr;
    }
} 
?>
